﻿using System.Windows;
using System.Windows.Media;
using MindFusion.Diagramming.Wpf;

namespace BrokenLink
{
	public class MyDiagram : Diagram
	{
		public MyDiagram()
		{
			var gridHeight = 16;
			var gridWidth = 16;
			var routingGridSize = 8;
			byte routingTurnCost = 160;
			byte routingCrossingcosts = 5;
			var autoAlginNodes = true;
			var snapToGrid = true;
			var showGrid = true;
			byte nodeVicinityCost = 8;
			double nodeVicinitySize = 12;
			double autoAlignDistance = 32;

			GridSizeX = gridWidth;
			GridSizeY = gridHeight;
			AutoAlignNodes = autoAlginNodes;
			AutoAlignDistance = autoAlignDistance;
			AlignToGrid = snapToGrid;
			ShowGrid = showGrid;

			RoutingOptions.GridSize = routingGridSize;
			RoutingOptions.TurnCost = routingTurnCost;
			RoutingOptions.CrossingCost = routingCrossingcosts;
			RoutingOptions.NodeVicinityCost = nodeVicinityCost;
			RoutingOptions.NodeVicinitySize = nodeVicinitySize;

			LinkRouter = new GridRouter();
			RoutingOptions.Anchoring = Anchoring.Keep;
			HitTestPriority = HitTestPriority.ZOrder;
			BackBrush = Brushes.Transparent;
			SnapToAnchor = SnapToAnchor.OnCreateOrModify;
			ShowAnchors = ShowAnchors.Auto;
			RouteLinks = true;
			AllowSelfLoops = false;
			Behavior = Behavior.DrawLinks;
			AllowSplitLinks = false;
			AlignToGrid = true;
			LinkShape = LinkShape.Cascading;
			AutoSnapLinks = true;
			AutoSnapDistance = 10;
			LinkHitDistance = 3;
			MergeThreshold = 5;
			DelKeyAction = DelKeyAction.None;
			MinimumNodeSize = new Size(2, 2);
			ShowDisabledHandles = false;
			AllowUnanchoredLinks = false;
			Selection.AllowMultipleSelection = true;
			Selection.IncludeItemsIfIntersect = false;

			ModificationStart = ModificationStart.SelectedOnly;
			SelectionOnTop = false;

			AutoResize = AutoResize.None;
		}
	}
}