﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using MindFusion.Diagramming.Wpf;


namespace BrokenLink
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
		}

		private void Window_Loaded(object sender, RoutedEventArgs e)
		{
			var ap1 = new AnchorPattern(new[] 
			{
				new AnchorPoint(50, 0, true, true), 
				new AnchorPoint(50, 100, true, true)
			}, "ap1");

			var ap2 = new AnchorPattern(new[] 
			{
				new AnchorPoint(50, 0, true, true), 
				new AnchorPoint(100, 50, true, true), 
				new AnchorPoint(50, 100, true, true),
				new AnchorPoint(0, 50, true, true)
			}, "ap2");

			var node1 = new DiagramNodeAdapter(new TestVisual());
			node1.Bounds = new Rect(200, 150, 20, 60);
			node1.AnchorPattern = ap1;
			diag.Nodes.Add(node1);

			var node2 = new DiagramNodeAdapter(new TestVisual());
			node2.Bounds = new Rect(320, 150, 20, 60);
			node2.AnchorPattern = ap1;
			diag.Nodes.Add(node2);

			var node3 = new ShapeNode();
			node3.Bounds = new Rect(268, 240, 4, 4);
			node3.AnchorPattern = ap2;
			diag.Nodes.Add(node3);

			diag.LinkHeadShape = null;
			var l1 = diag.Factory.CreateDiagramLink(node3, node1);
			l1.OriginAnchor = l1.DestinationAnchor = 0;
			var l2 = diag.Factory.CreateDiagramLink(node3, node2);
			l2.OriginAnchor = l2.DestinationAnchor = 0;
			var l3 = diag.Factory.CreateDiagramLink(node3, node1);
			l3.OriginAnchor = 3; l3.DestinationAnchor = 1;
			var l4 = diag.Factory.CreateDiagramLink(node3, node2);
			l4.OriginAnchor = 1; l4.DestinationAnchor = 1;

			diag.RouteAllLinks();
		}
	}

	class TestVisual : FrameworkElement
	{
		protected override void OnRender(DrawingContext drawingContext)
		{
			base.OnRender(drawingContext);

			var w = ActualWidth;
			var h = ActualHeight;

			var black = new Pen(Brushes.Black, 2);
			drawingContext.DrawLine(black, new Point(w / 2, 0), new Point(w / 2, h / 5));
			drawingContext.DrawLine(black, new Point(0, 0), new Point(w, 2 * h / 5));
			drawingContext.DrawLine(black, new Point(w, 0), new Point(0, 2 * h / 5));
			drawingContext.DrawLine(black, new Point(w / 2, h), new Point(w /2 , 4 * h / 5));
			drawingContext.DrawLine(black, new Point(w / 2, 4 * h / 5), new Point(-w / 3, h / 2));
		}

		protected override Size MeasureOverride(Size availableSize)
		{
			return new Size(20, 40);
		}
	}
}
